//-----------------------------------------------------------
// Some extras - god/ghost/fly summons etc
//-----------------------------------------------------------
class XConsole_AdminTab expands UWindowPageWindow
config(XConsole);

// controls
var UWindowSmallButton GodButton, FlyButton, GhostButton, WalkButton, SummonUWButton, SummonUTButton;
var UWindowSmallButton LoginButton, LogoutButton, MonsterButton;
var UWindowSmallButton CannonButton, ViewButton;
var UWindowComboControl UWCombo, UTWCombo, MonsterCombo, SlomoCombo, JumpCombo;
var UWindowEditControl LoginControl;

// strings for weaponry etc
var string AdminPre, LoginText, LogoutText, HelpLoginText, HelpLogoutText;
var config string Creds[100];
// Misc
var bool bCreated;
var name LogTag;
var color red, blue, grey;

// Classes
var Console   Con;
var AConsole  XCon;

struct Weapons{
	var string Name;
	var string Summon;
};

struct PowerUps{
	var string Name;
	var string Summon;
};

struct Monsters{
	var string Name;
	var string Summon;
};

var config Weapons Weapon[30];
var config PowerUps PowerUp[30];
var config Monsters Monster[30];

final function DoVars(){
    Con=root.Console;
    XCon=AConsole(Con);
    XCon.AdminTab=self;
    AdminPre="admin ";
    LoginText="Login:";
    LogoutText="Logout";
    HelpLoginText="Admin Login";
    HelpLogoutText="Admin Logout";
}

// Buttons etc
final function DoButtons(){
	local byte i, Col, Row;

    UWCombo = UWindowComboControl(CreateControl(class'UWindowComboControl', 9, 5,200 ,1 ) );
    UWCombo.SetEditable(false);
    UWCombo.bAlwaysBehind=true;
	for(i=0;i<30;i++)
    if (Weapon[i].Name!="") UWCombo.AddItem(Weapon[i].Name);
    UWCombo.SetSelectedIndex(0);

    UTWCombo = UWindowComboControl(CreateControl(class'UWindowComboControl', 9, 22,200 ,1 ) );
    UTWCombo.SetEditable(false);
    UTWCombo.bAlwaysBehind=true;
	for(i=0;i<30;i++)
    if (Powerup[i].Name!="") UTWCombo.AddItem(Powerup[i].Name);
    UTWCombo.SetSelectedIndex(0);

    MonsterCombo = UWindowComboControl(CreateControl(class'UWindowComboControl', 9, 39,200 ,1 ) );
    MonsterCombo.SetEditable(false);
    MonsterCombo.bAlwaysBehind=true;
	for(i=0;i<30;i++)
    if (Monster[i].Name!="") MonsterCombo.AddItem(Monster[i].Name);
    MonsterCombo.SetSelectedIndex(0);

    SummonUWButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 59, 5,50 ,1 ) );
    SummonUWButton.SetText("Summon");
    SummonUTButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 59, 22,50 ,1 ) );
    SummonUTButton.SetText("Summon");
    MonsterButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 59, 39,50 ,1 ) );
    MonsterButton.SetText("Summon");

    JumpCombo = UWindowComboControl(CreateControl(class'UWindowComboControl', 339, 39, 130, 1));
    JumpCombo.SetFont(F_Normal);
    JumpCombo.SetEditable(False);
    JumpCombo.bAlwaysBehind=true;
    JumpCombo.AddItem("JumpZ","357");
    JumpCombo.AddItem("357","357");
    JumpCombo.AddItem("650","650");
    JumpCombo.AddItem("1000","1000");
    JumpCombo.AddItem("2000","2000");
    JumpCombo.AddItem("3000","3000");
    JumpCombo.SetSelectedIndex(0);

    SlomoCombo = UWindowComboControl(CreateControl(class'UWindowComboControl', 274, 39, 130, 1));
    SlomoCombo.SetFont(F_Normal);
    SlomoCombo.SetEditable(False);
    SlomoCombo.bAlwaysBehind=true;
    SlomoCombo.AddItem("Slomo","1");
    SlomoCombo.AddItem("0.25","0.25");
    SlomoCombo.AddItem("0.50","0.50");
    SlomoCombo.AddItem("0.75","0.75");
    SlomoCombo.AddItem("1.00","1.00");
    SlomoCombo.AddItem("1.25","1.25");
    SlomoCombo.AddItem("1.50","1.50");
    SlomoCombo.AddItem("1.75","1.75");
    SlomoCombo.AddItem("2.00","2.00");
    SlomoCombo.SetSelectedIndex(0);

    GodButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 209, 5, 65,1 ) );
    GodButton.SetText("God");
    FlyButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 274, 5, 65,1 ) );
    FlyButton.SetText("Fly");
    GhostButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 339, 5, 65,1 ) );
    GhostButton.SetText("Ghost");
    WalkButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 404, 5, 65,1 ) );
    WalkButton.SetText("Walk");

    CannonButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 209, 39, 65,1 ) );
    CannonButton.SetText("Cannons");
    CannonButton.ToolTipString="R.I.P. Autocannons";

    ViewButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 274, 39, 65,1 ) );
    ViewButton.SetText("View");
    ViewButton.ToolTipString="Cheat View Pawns";

    LoginControl = UWindowEditControl(CreateControl(class'UWindowEditControl', -47, 22, 104 ,20));
    LoginControl.SetFont(F_Normal);
    LoginControl.SetNumericOnly(False);
    LoginControl.SetMaxLength(20);
    LoginControl.SetHistory(True);
    LoginControl.bAlwaysBehind=true;

    LoginButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 5, 5,54 ,1 ));
    LoginButton.SetText(LoginText);
    LoginButton.ToolTipString=HelpLoginText;

    LogoutButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 5, 40,54 ,1 ));
    LogoutButton.SetText(LogoutText);
    LogoutButton.ToolTipString=HelpLogoutText;

}
// notify
function Notify(UWindowDialogControl C, byte E){

	local string S;
    local PlayerReplicationInfo PRI;

     if(!bCreated) return;
     PRI = GetPlayerOwner().PlayerReplicationInfo;

     if(PRI!=none)
     {
         if(PRI.bAdmin)
         {
             AdminPre="admin ";
         }
         if(XCon.ServerTab!=none)
         XCon.ServerTab.AdminPre=AdminPre;
         
     }

	S=LoginControl.GetValue();

    switch(E)
      {
          case DE_Click:
          switch(C)
          {
              case GodButton:xcon.consolecommand("god");break;
              case FlyButton:xcon.consolecommand("fly");break;
              case GhostButton:xcon.consolecommand("ghost");break;
              case WalkButton:xcon.consolecommand("walk");break;
              case SummonUWButton:xcon.consolecommand(AdminPre $ "summon " $ Weapon[UWCombo.getselectedindex()].Summon);break;
              case SummonUTButton:xcon.consolecommand(AdminPre $ "summon " $ Powerup[UTWCombo.getselectedindex()].Summon);break;
              case MonsterButton:xcon.consolecommand(AdminPre $ "summon " $ Monster[MonsterCombo.getselectedindex()].Summon);break;
              case CannonButton:XCon.ConsoleCommand("admin killall teamcannon");break;
              case ViewButton:XCon.ConsoleCommand("admin cheatview pawn");break;
              case LoginButton:Login(S);break;
              case LogoutButton:xcon.consolecommand("adminLogout");break;
          }
		  case DE_Click:
			switch(C)
			{
				case LoginControl:
				return;
			}
			
          case DE_EnterPressed:
              switch(C)
              {
        		  case LoginControl:Login(S);break;
               }

          case DE_Change:
               switch(C)
               {
                   case SlomoCombo:XCon.ConsoleCommand("admin slomo " $ SlomoCombo.GetValue2());break;
                   case JumpCombo:XCon.ConsoleCommand("admin setjumpz " $ JumpCombo.GetValue2());break;
				   break;
               }
       }
     Super.Notify(C, E);
}

final function Login(string S)
{
	local int i;
	local levelinfo level;
	local bool bPassSaved;
	local string IP;

	IP=GetPlayerOwner().level.GetAddressUrl();
	AdminPre="admin ";
	if ( S != "" )
	{
		for ( i=0; i<100; i++ )
		{
			if(	left(Creds[i],InStr(Creds[i],"@")) == IP )
			{
				Creds[i] = IP $ "@" $ S;
//				echo (Creds[i]);
				bPassSaved=true;
				break;
			}
		}
		
		for ( i=0; i<100; i++ )
		{
			if (bPassSaved) break;
			if (Creds[i] == "" )
			{
				Creds[i] = IP $ "@" $ S;
//				echo (Creds[i]);
				bPassSaved=true;
				break;
			}
		}

	XCon.ConsoleCommand( "adminlogin " $ S);
	}
	
	else

	{
		for ( i=0; i<100; i++ )
		{
			if( left(Creds[i], InStr(Creds[i],"@")) == IP )
			{
				XCon.ConsoleCommand( "adminlogin " $ Mid(Creds[i],Instr(Creds[i],"@")+1));
//				echo(Creds[i]);
			}
		}
	}


    if(XCon.ServerTab!=none)
		XCon.ServerTab.AdminPre=AdminPre;
	
	SaveConfig();
}

final function SetNewPass(string S)
{
	local int i;
	local levelinfo level;
	local bool bPassSaved;
	local string IP;
	
	if(S=="") return;
	IP=GetPlayerOwner().level.GetAddressUrl();

	for ( i=0; i<100; i++ )
	{
		if(	left(Creds[i],InStr(Creds[i],"@")) == IP )
		{
			Creds[i] = IP $ "@" $ S;
			bPassSaved=true;
			break;
		}
	}
	
	for ( i=0; i<100; i++ )
	{
		if (bPassSaved) break;
		if (Creds[i] == "" )
		{
			Creds[i] = IP $ "@" $ S;
			bPassSaved=true;
			break;
		}
	}

	SaveConfig();
}


function WindowShown(){
	local levelinfo level;
	local string S, IP;
	local int i;

	IP=GetPlayerOwner().level.GetAddressUrl();
	for ( i=0; i<100; i++ )
	{
		S=left(Creds[i], InStr(Creds[i], "@"));
		if (S == IP )
		{				
			LoginControl.SetValue(Mid(Creds[i], InStr(Creds[i], "@")+1));
			break;
		}
		LoginControl.Clear();
	}
}

function Created(){

    DoVars();
    DoButtons();
    super.Created();
	bCreated=true;
	SaveConfig();
}

final function Echo(coerce string s){XCon.Echo(S);}

defaultproperties
{
    Red=(R=255,G=0,B=0,A=0),
    Weapon(0)=(Name="Chainsaw",Summon="Chainsaw"),
    Weapon(1)=(Name="Enforcer",Summon="Enforcer"),
    Weapon(2)=(Name="Impact",Summon="ImpactHammer"),
    Weapon(3)=(Name="Minigun",Summon="Minigun2"),
    Weapon(4)=(Name="Pulse",Summon="PulseGun"),
    Weapon(5)=(Name="Ripper",Summon="Ripper"),
    Weapon(6)=(Name="Shock",Summon="ShockRifle"),
    Weapon(7)=(Name="Insta Shock",Summon="Supershockrifle"),
    Weapon(8)=(Name="Sniper",Summon="SniperRifle"),
    Weapon(9)=(Name="Bio",Summon="ut_biorifle"),
    Weapon(10)=(Name="Rocket Launcher",Summon="ut_eightball"),
    Weapon(11)=(Name="Flak",Summon="ut_Flakcannon"),
    Weapon(12)=(Name="Deemer",Summon="warheadlauncher"),
    PowerUp(0)=(Name="Trans",Summon="translocator"),
    PowerUp(1)=(Name="Boots",Summon="ut_jumpboots"),
    PowerUp(2)=(Name="Amp",Summon="udamage"),
    PowerUp(3)=(Name="Keg",Summon="healthpack"),
    PowerUp(4)=(Name="Belt",Summon="ut_shieldbelt"),
    PowerUp(5)=(Name="Armour",Summon="armor2"),
    PowerUp(6)=(Name="Pads",Summon="thighpads"),
    PowerUp(7)=(Name="Invis",Summon="ut_invisibility"),
    PowerUp(8)=(Name="Flashlight",Summon="unrealshare.flashlight"),
    Monster(0)=(Name="Gasbag",Summon="unreali.Gasbag"),
    Monster(1)=(Name="Giant Gasbag",Summon="unreali.GiantGasbag"),
    Monster(2)=(Name="Krall",Summon="unreali.Krall"),
    Monster(3)=(Name="Krall Elite",Summon="unreali.KrallElite"),
    Monster(4)=(Name="Legless Krall",Summon="unreali.LeglessKrall"),
    Monster(5)=(Name="Mercenary",Summon="unreali.Mercenary"),
    Monster(6)=(Name="Mercenary Elite",Summon="unreali.MercenaryElite"),
    Monster(7)=(Name="Pupae",Summon="unreali.Pupae"),
    Monster(8)=(Name="Queen",Summon="unreali.Queen"),
    Monster(9)=(Name="Squid",Summon="unreali.Squid"),
    Monster(10)=(Name="Titan",Summon="unreali.Titan"),
    Monster(11)=(Name="Stone Titan",Summon="unreali.StoneTitan"),
    Monster(12)=(Name="Warlord",Summon="unreali.Warlord"),
    Monster(13)=(Name="Manta",Summon="unreali.Manta"),
    Monster(14)=(Name="Giant Manta",Summon="unreali.GiantManta"),
    Monster(15)=(Name="Brute",Summon="unreali.Brute"),
    Monster(16)=(Name="Behemoth",Summon="unreali.Behemoth"),
    Monster(17)=(Name="Bloblet",Summon="unreali.Bloblet"),
    Monster(18)=(Name="Ice Skaarj",Summon="unreali.IceSkaarj"),
    Monster(19)=(Name="Skaarj Assassin",Summon="unreali.SkaarjAssassin"),
    Monster(20)=(Name="Skaarj Berserker",Summon="unreali.SkaarjBerserker"),
    Monster(21)=(Name="Skaarj Lord",Summon="unreali.SkaarjLord"),
    Monster(22)=(Name="Horsefly Swarm",Summon="unrealshare.horseflyswarm"),
    Monster(23)=(Name="Nali",Summon="unrealshare.nali"),
    Monster(24)=(Name="Nali Priest",Summon="unrealshare.nalipriest"),
    Monster(25)=(Name="Cow",Summon="unrealshare.cow"),
}
